//+------------------------------------------------------------------+
//|                                                QQE Adv w Alerts  |
//|                                     Copyright  2010, Pro4x.com  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Pro4x.com"
#property link      "tim@pro4x.com"
#include <stdlib.mqh>

#define vers     "23.Jan.2011"
#define Major    "2"
#define Minor    "01"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_style1 STYLE_SOLID
#property indicator_width1 2
#property indicator_color2 Yellow
#property indicator_style2 STYLE_DOT
#property indicator_level1 50
#property indicator_levelcolor Aqua
#property indicator_levelstyle STYLE_DOT
//----
extern string NOTESETTINGS="=== INDICATOR SETTINGS ===";
extern int    MaxBars = 1000;
extern int    SF=1;
extern int    RSI_Period=8;
extern double DAR_Factor = 3;

string SIGNALS="=== SIGNALS ===";
bool   ShowSignalLines=False;
int    SignalLineWidth=2;
color  SignalLineColorLong=Lime;
color  SignalLineColorShort=Red;

extern string ALERTS="=== ALERTS ===";
string _Mid = "- - - - MID LEVEL ALERTS - - - -";
int    Mid_AlertLevel=50;
bool   Mid_MsgAlerts=False;
bool   Mid_SoundAlerts=False;
string Mid_SoundAlertFile="alert.wav";
bool   Mid_eMailAlerts=False;

string _Sig = "- - - - SIGNAL LINE ALERTS - - - -";
extern bool   Sig_MsgAlerts=true;
extern bool   Sig_SoundAlerts=true;
extern string Sig_SoundAlertFile="alert.wav";
extern bool   Sig_eMailAlerts=false;

int Wilders_Period;
int StartBar, LastAlertBar;
datetime LastAlertTime;
double TrLevelSlow[];
double AtrRsi[];
double MaAtrRsi[];
double Rsi[];
double RsiMa[];
string base;
string GVP="QQE"; //GVP = Global Variable Prefix.
int Counter;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   Wilders_Period=RSI_Period * 2 - 1;
   if (Wilders_Period < SF)
      StartBar=SF;
   else
      StartBar=Wilders_Period;

   //If using a template objects can overlap, so ensure a clean slate before creating any new objects
   DeleteObjects(GVP);

//----
   IndicatorBuffers(6);
   SetIndexBuffer(0, RsiMa);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexLabel(0, "Value 1");
   SetIndexDrawBegin(0, StartBar);
   SetIndexStyle(1, DRAW_LINE, STYLE_DOT);
   SetIndexBuffer(1, TrLevelSlow);
   SetIndexLabel(1, "Value 2");
   SetIndexDrawBegin(1, StartBar);
   SetIndexBuffer(2, AtrRsi);
   SetIndexBuffer(3, MaAtrRsi);
   SetIndexBuffer(4, Rsi);

   SetIndexLabel(0, "RsiMa");
   SetIndexLabel(0, "TrLevelSlow");
   
   IndicatorShortName("QQE ADV (" + SF + "," + RSI_Period + "," + DoubleToStr(DAR_Factor,1) + ")   " );
   IndicatorDigits(2);
   
   string base="QQE ADV " + Symbol()+ ", TF: " + TF2Str(Period());

   LastAlertBar=Bars;
   Counter = 0;
   return(0);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
{   
   //If using a template objects can overlap, so ensure a clean slate before creating any new objects
   DeleteObjects(GVP);
   Comment("");
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int counted, i;
   double rsi0, rsi1, dar, tr, dv;
   string Subj, Msg;

//----
   if(Bars<=StartBar)
      return(0);
//----      
   counted=IndicatorCounted();
   if(counted < 1)
   {
      for(i=Bars - StartBar; i < Bars; i++)
      {
         TrLevelSlow[i]=0.0;
         AtrRsi[i]=0.0;
         MaAtrRsi[i]=0.0;
         Rsi[i]=0.0;
         RsiMa[i]=0.0;
      }
   }
   counted=Bars - counted - 1;
   counted = MathMin(counted, MaxBars);
  
//----
   for(i=counted; i>=0; i--)
      Rsi[i]=iRSI(NULL, 0, RSI_Period, PRICE_CLOSE, i);
   for(i=counted; i>=0; i--)
     {
      RsiMa[i]=iMAOnArray(Rsi, 0, SF, 0, MODE_EMA, i);
      AtrRsi[i]=MathAbs(RsiMa[i + 1] - RsiMa[i]);
     }
   for(i=counted; i>=0; i--)
      MaAtrRsi[i]=iMAOnArray(AtrRsi, 0, Wilders_Period, 0, MODE_EMA, i);
//----
   i=counted + 1;
   tr=TrLevelSlow[i];
   rsi1=iMAOnArray(Rsi, 0, SF, 0, MODE_EMA, i);
   int FirstBar=0;
   while(i >= FirstBar)
   {
      i--;
      rsi0=iMAOnArray(Rsi, 0, SF, 0, MODE_EMA, i);
      dar=iMAOnArray(MaAtrRsi, 0, Wilders_Period, 0, MODE_EMA, i) * DAR_Factor;
      dv=tr;
      if (rsi0 < tr)
        {
         tr=rsi0 + dar;
         if (rsi1 < dv)
            if (tr > dv)
               tr=dv;
        }
      else if (rsi0 > tr)
      {
            tr=rsi0 - dar;
            if (rsi1 > dv)
               if (tr < dv)
                  tr=dv;
      }
      TrLevelSlow[i]=tr;
      rsi1=rsi0;
        
      if ( RsiMa[i+1]>TrLevelSlow[i+1] && RsiMa[i]<TrLevelSlow[i] )
      {
        if(ShowSignalLines)
        {
           Counter++;
           CreateVLine(GVP + Counter,Time[i], SignalLineColorShort, SignalLineWidth);
        }
      
        if (Bars>LastAlertBar && i==FirstBar)
        {
           LastAlertBar=Bars;
           Subj=base + " Downward Cross.";
           Msg=Subj + " @ " + TimeToStr(TimeLocal(),TIME_SECONDS);
           DoAlerts(Sig_MsgAlerts,Sig_SoundAlerts,Sig_eMailAlerts,Sig_SoundAlertFile,Msg,Subj);
        }
     }

      else if ( RsiMa[i+1]<TrLevelSlow[i+1] && RsiMa[i]>TrLevelSlow[i] )
      {
        if(ShowSignalLines)
        {
           Counter++;
           CreateVLine(GVP + Counter,Time[i], SignalLineColorLong, SignalLineWidth);
        }

        if (Bars>LastAlertBar && i==FirstBar)
        {
           LastAlertBar=Bars;
           Subj=base + " Upward Cross.";
           Msg=Subj + " @ " + TimeToStr(TimeLocal(),TIME_SECONDS);
           DoAlerts(Sig_MsgAlerts,Sig_SoundAlerts,Sig_eMailAlerts,Sig_SoundAlertFile,Msg,Subj);
        }
      }

      /*else if ((RsiMa[i+1]<Mid_AlertLevel && RsiMa[i]>Mid_AlertLevel) ||(RsiMa[i+1]>Mid_AlertLevel && RsiMa[i]<Mid_AlertLevel) )
      {
         base="QQE " + Symbol()+ ", TF: " + TF2Str(Period());
         Subj=base + ", " + Mid_AlertLevel + " level Cross Up";
         if (RsiMa[i+1]>Mid_AlertLevel && RsiMa[i]<Mid_AlertLevel) Subj=base + " " +  Mid_AlertLevel + " level Cross Down";
         Msg=Subj + " @ " + TimeToStr(TimeLocal(),TIME_SECONDS);

         if(ShowSignalLines)
         {
            bool isShort = (RsiMa[i+1]>Mid_AlertLevel && RsiMa[i]<Mid_AlertLevel);
            Counter++;
            if(!isShort) CreateVLine(GVP + Counter,Time[i], SignalLineColorShort, SignalLineWidth);
            else  CreateVLine(GVP + Counter,Time[i], SignalLineColorShort, SignalLineWidth);
         }

         if (Bars>LastAlertBar)
         {
            LastAlertBar=Bars;
            DoAlerts(Mid_MsgAlerts,Mid_SoundAlerts,Mid_eMailAlerts,Mid_SoundAlertFile,Msg,Subj);
         }
      }*/
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DoAlerts(bool MsgAlerts, bool SoundAlerts, bool eMailAlerts, string SoundFile, string msgText, string eMailSub)
{
   if (MsgAlerts)   Alert(msgText);
   if (SoundAlerts) PlaySound(SoundFile);
   if (eMailAlerts) SendMail(eMailSub, msgText);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string TF2Str(int period)
  {
   switch(period)
     {
      case PERIOD_M1: return("M1");
      case PERIOD_M5: return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1: return("H1");
      case PERIOD_H4: return("H4");
      case PERIOD_D1: return("D1");
      case PERIOD_W1: return("W1");
      case PERIOD_MN1: return("MN");
     }
   return(Period());
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CreateVLine(string LineName, datetime vTime, color LineColor, int LineWidth)
{
   if(ObjectFind(LineName)==-1) 
      ObjectCreate(LineName,OBJ_VLINE,0,vTime,0);
   else
   {
      if(!ObjectMove(LineName, 0, vTime, 0))
      {
         int Err = GetLastError();
         Print("QQE - Error with line " + LineName);
         Print("Error: " + Err + ", " + ErrorDescription(Err));
      }
   }
   ObjectSet(LineName,OBJPROP_COLOR,LineColor);
   ObjectSet(LineName,OBJPROP_WIDTH, LineWidth);
}

//+------------------------------------------------------------------+
//| Delete Objects that match ObjName                                |
//+------------------------------------------------------------------+
void DeleteObjects(string ObjName)
{
   for (int i=ObjectsTotal()-1; i >= 0; i--) 
   {
     string name = ObjectName(i);
     if (StringFind(name, ObjName) > -1) ObjectDelete(name);
   }
}
  
//+------------------------------------------------------------------+